#!/bin/bash

# This is a sample cron file. According to it's name it will go to
# ~/system/cron/cron.10min. You may also let your Pluginscript create a
# symbolic link dynamically in ~/system/cron/cron.10min which links to your
# cron-script in ~/webfrontend/cgi instead (which is prefered). Use NAME from
# /data/system/plugindatabase.dat in that case as scriptname! Otherwise
# the cron script will not be uninstalled cleanly.

PCONFIG=$LBPCONFIG/$PDIR/pvsolcast/solcast_config.json
SYSCONFIG=$LBSCONFIG/general.cfg
PLOG1=$LBPLOG/$PDIR/pvsolcast/solcast_1.log
PLOG2=$LBPLOG/$PDIR/pvsolcast/solcast_2.log
PLOG3=$LBPLOG/$PDIR/pvsolcast/solcast_3.log
PLOG4=$LBPLOG/$PDIR/pvsolcast/solcast_4.log
active_1=$(jq '.system_1.active' $PCONFIG | tr -d '"')
active_2=$(jq '.system_2.active' $PCONFIG | tr -d '"') 
active_3=$(jq '.system_3.active' $PCONFIG | tr -d '"')
active_4=$(jq '.system_4.active' $PCONFIG | tr -d '"')
debug=$(jq '.debug' $PCONFIG | tr -d '"')
declare -a  request_time=$(jq '.timer' $PCONFIG | tr -d '"' | tr -d ',' | tr \[ \( | tr \] \)) 
request_time=("0" "${request_time[@]}")
hour=$(date +"%k")
clock=$(date '+%Y-%m-%d %H:%M:%S')
reqe=0

if [ ! -d "$LBPLOG/$PDIR/pvsolcast/" ]; then
  mkdir $LBPLOG/$PDIR/pvsolcast/
fi

iniparser() {
    INI_FILE=$1
    INI_SECTION=$2
    eval `sed -e 's/[[:space:]]*\=[[:space:]]*/=/g' \
        -e 's/;.*$//' \
        -e 's/[[:space:]]*$//' \
        -e 's/^[[:space:]]*//' \
        -e "s/^\(.*\)=\([^\"']*\)$/$INI_SECTION\1=\"\2\"/" \
        < $INI_FILE \
        | sed -n -e "/^\[$INI_SECTION\]/,/^\s*\[/{/^[^;].*\=.*/p;}"`
}
 
iniparser $SYSCONFIG "WEBSERVER"
iniparser $SYSCONFIG "NETWORK"

if [ $active_1 == 1 ]; then
for i in "${request_time[@]}"
do
	if [ $hour == $i ];then
	  if [ $debug == 1 ]; then 
		echo "$clock - Request start by cron" >> $PLOG1
	  fi	  
	  /usr/bin/php $LBPHTML/pvsolcast/solcast.php 1 >/dev/null 2>&1
	  reqe=1
	fi
done
fi

if [ $active_2 == 1 ]; then
for i in "${request_time[@]}"
do
	if [ $hour == $i ];then
	  if [ $debug == 1 ]; then 
		echo "$clock - Request start by cron" >> $PLOG2
	  fi
	  /usr/bin/php $LBPHTML/pvsolcast/solcast.php 2 >/dev/null 2>&1
	  reqe=1
	fi
done
fi 

if [ $active_3 == 1 ]; then
for i in "${request_time[@]}"
do
	if [ $hour == $i ];then
	  if [ $debug == 1 ]; then 
		echo "$clock - Request start by cron" >> $PLOG3
	  fi
	  /usr/bin/php $LBPHTML/pvsolcast/solcast.php 3 >/dev/null 2>&1
	  reqe=1
	fi
done
fi
if [ $active_4 == 1 ]; then
for i in "${request_time[@]}"
do
	if [ $hour == $i ];then
	  if [ $debug == 1 ]; then 
		echo "$clock - Request start by cron" >> $PLOG4
	  fi
	  /usr/bin/php $LBPHTML/pvsolcast/solcast.php 4 >/dev/null 2>&1
	  reqe=1
	fi
done
fi

if [ $hour == 0 ];then
	sleep 1
	/usr/bin/php "$LBPHTML/pvsolcast/solcast_sum_mn.php" 
fi

if [ $reqe -eq 1 ]; then
	sleep 1
	/usr/bin/php $LBPHTML/pvsolcast/solcast_sum.php >/dev/null 2>&1
fi






   	  if [ $debug == 1 ]; then
		if [ $reqe == 0 ]; then
			if [ $active_1 == 1 ]; then
				echo "$clock - Hourly-Cron, Time not set for Request" >> $PLOG1
			fi
			if [ $active_2 == 1 ]; then
				echo "$clock - Hourly-Cron, Time not set for Request" >> $PLOG2
			fi
			if [ $active_3 == 1 ]; then
				echo "$clock - Hourly-Cron, Time not set for Request" >> $PLOG3
			fi
			if [ $active_4 == 1 ]; then
				echo "$clock - Hourly-Cron, Time not set for Request" >> $PLOG4
			fi			
		fi
	  fi
