<?php
require_once "loxberry_system.php";
include 'solcast_functions.php';
error_reporting(0);

//CONFIG
$file_config = $lbpconfigdir . '/solcast_config.json';

//---------------------------------------------------------------------------------------------------
if (defined('STDIN')) {
  $system = $argv[1];
} else {
  $system  = $_GET['system'];
}
$file_log_i  = $lbplogdir . '/solcast_'.$system.'.log';
//---------------------------------------------------------------------------------------------------
//READ CONFIG-FILE
$config      = json_decode(file_get_contents($file_config), true);

if ($system < 1 || $system > 5) {
    echo 'Paramter: system has to be between 1-5';
	exit();
}
$active  = $config['system_' . $system . ''][active];
$api     = $config['system_' . $system . ''][api];
$rt_id     = $config['system_' . $system . ''][rt_id];
$debug   = $config['debug'];
$ms_ip = $config['miniserver']['ip'];
$ms_port = $config['miniserver']['port'];
$send_mqtt = $config['send_mqtt'];
$send_udp = $config['send_udp'];

if (!isset($send_udp) && !isset($send_mqtt)) {
	$send_mqtt = 1;
}

if (empty($install)) {
$loss_cal='&loss_factor=' . $loss;	
} else {
$loss_cal='&install_date=' . $install;	
}

$url='https://api.solcast.com.au/rooftop_sites/'. $rt_id .'/forecasts?format=json&api_key=' . $api;

//Get Data
$ch = curl_init();
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5); 
curl_setopt($ch, CURLOPT_TIMEOUT, 20);
curl_setopt($ch, CURLOPT_URL, $url);
$result_c = curl_exec($ch);
$info_c = curl_getinfo($ch);
$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
curl_close($ch);

$result   = json_decode(($result_c), true);

//Prepare arrays
$arr_today    = array();
$arr_tomorrow = array();
$arr_48       = array();
$arr_submit   = array();

//Prepare Time
$this_tz_str = date_default_timezone_get();
$this_tz     = new DateTimeZone($this_tz_str);
$now         = new DateTime("now", $this_tz);
$offset      = $this_tz->getOffset($now) / 3600;
$today       = date("Y-m-d");
$epoch       = new DateTime();
$time_now    = date("Y-m-d H:i:s");
$hour_now    = date("G");
$tomorrow    = date("Y-m-d", strtotime("+1 day"));

$log_text=http_codes($httpcode);
$log_text='Code: '.$httpcode.' / '.$log_text;
if ($debug == 1) {
	if ( $httpcode == 200 ) {
		echo $log_text.'<br><br>';
	} else {
		echo $log_text.'<br><br>';
		echo '<pre>';
		print_r ($info_c);
		echo '</pre>';
	}
log_i($log_text, $file_log_i);
log_i($info_c, $file_log_i);
}

if ($httpcode == 200) {
if ($debug == 1) {
log_i($result, $file_log_i);
}
//Prepare Data
$i = 0;
foreach ($result['forecasts'] as $row) {
    if ($i % 2 == 0) {
        $hourx = date('G', strtotime($row['period_end']));
        $datex = date('Y-m-d', strtotime($row['period_end']));
        if ($datex == $today) {
            $arr_today[$hourx] = $row['pv_estimate'];
        }
        if ($datex == $tomorrow) {
            $arr_tomorrow[$hourx] = $row['pv_estimate'];
        }
    }
    $i++;
}
//Array 48h
for ($x = 0; $x <= 47; $x++) {
    if ($x < 24) {
        if ($arr_today[$x] == NULL) {
            $value = 0;
        } else {
            $value = $arr_today[$x];
        }
        $arr_48[$x] = $value;
    } else {
        if ($arr_tomorrow[$x - 24] == NULL) {
            $value = 0;
        } else {
            $value = $arr_tomorrow[$x - 24];
        }
        $arr_48[$x] = $value;
    }
}

//Hourly Today
for ($x = 0; $x <= 23; $x++) {
    if ($arr_today[$x] == NULL) {
        $value = 0;
    } else {
        $value = $arr_today[$x];
    }
    $arr_submit['hourly_td_kw'][$x]   = $value;
    $arr_submit['hourly_td_w'][$x] = $value * 1000;
}
//Hourly Tomorrow
for ($x = 0; $x <= 23; $x++) {
    if ($arr_tomorrow[$x] == NULL) {
        $value = 0;
    } else {
        $value = $arr_tomorrow[$x];
    }
    $arr_submit['hourly_tm_kw'][$x] = $value;
    $arr_submit['hourly_tm_w'][$x]  = $value * 1000;
}

//Next
$next_3 = 0;
for ($x = $hour_now + 1; $x <= $hour_now + 3; $x++) {
    $next_3 = $next_3 + $arr_48[$x];
}
$next_6 = 0;
for ($x = $hour_now + 1; $x <= $hour_now + 6; $x++) {
    $next_6 = $next_6 + $arr_48[$x];
}
$next_9 = 0;
for ($x = $hour_now + 1; $x <= $hour_now + 9; $x++) {
    $next_9 = $next_9 + $arr_48[$x];
}
$next_12 = 0;
for ($x = $hour_now + 1; $x <= $hour_now + 12; $x++) {
    $next_12 = $next_12 + $arr_48[$x];
}
$next_24 = 0;
for ($x = $hour_now + 1; $x <= $hour_now + 24; $x++) {
    $next_24 = $next_24 + $arr_48[$x];
}
$daytime_morning = 0;
for ($x = 0; $x <= 12; $x++) {
    $daytime_morning = $daytime_morning + $arr_48[$x];
}
$daytime_afternoon = 0;
for ($x = 13; $x <= 23; $x++) {
    $daytime_afternoon = $daytime_afternoon + $arr_48[$x];
}

$tomorrow_morning = 0;
for ($x = 24; $x <= 35; $x++) {
    $tomorrow_morning = $tomorrow_morning + $arr_48[$x];
}
$tomorrow_afternoon = 0;
for ($x = 36; $x <= 47; $x++) {
    $tomorrow_afternoon = $tomorrow_afternoon + $arr_48[$x];
}

$arr_submit['time']['timezone']		   = $this_tz_str;
$arr_submit['time']['now']             = $time_now;
$arr_submit['time']['utc_offset']      = $offset;
$arr_submit['time']['epoch']           = $epoch->format('U');
$arr_submit['total']['td_kw']          = array_sum($arr_today);
$arr_submit['total']['td_w']           = array_sum($arr_today) * 1000;
$arr_submit['total']['tm_kw']          = array_sum($arr_tomorrow);
$arr_submit['total']['tm_w']           = array_sum($arr_tomorrow) * 1000;
$arr_submit['next']['3_kw']            = $next_3;
$arr_submit['next']['3_w']             = $next_3 * 1000;
$arr_submit['next']['6_kw']            = $next_6;
$arr_submit['next']['6_w']             = $next_6 * 1000;
$arr_submit['next']['9_kw']            = $next_9;
$arr_submit['next']['9_w']             = $next_9 * 1000;
$arr_submit['next']['12_kw']           = $next_12;
$arr_submit['next']['12_w']            = $next_12 * 1000;
$arr_submit['next']['24_kw']           = $next_24;
$arr_submit['next']['24_w']            = $next_24 * 1000;
$arr_submit['daytime']['morning_kw']    = $daytime_morning;
$arr_submit['daytime']['morning_w']     = $daytime_morning * 1000;
$arr_submit['daytime']['afternoon_kw'] = $daytime_afternoon;
$arr_submit['daytime']['afternoon_w']  = $daytime_afternoon * 1000;
$arr_submit['daytime_tm']['morning_kw']    = $tomorrow_morning;
$arr_submit['daytime_tm']['morning_w']     = $tomorrow_morning * 1000;
$arr_submit['daytime_tm']['afternoon_kw'] = $tomorrow_afternoon;
$arr_submit['daytime_tm']['afternoon_w']  = $tomorrow_afternoon * 1000;

$filename_data = $lbpdatadir . '/solcast_system_' . $system. '.txt';
$json_data = json_encode($arr_submit);
file_put_contents($filename_data, $json_data);

if($send_mqtt == 1) {
send_mqtt($system, $arr_submit);
}
if($send_udp == 1) {
send_udp($system, $arr_submit, $ms_ip, $ms_port);
}
}