<?php
//PREPARE ARRAY FOR MQTT
function prefixKey($prefix, $array)
{
    $result = array();
    foreach ($array as $key => $value) {
        if (is_array($value))
            $result = array_merge($result, prefixKey($prefix . $key . '_', $value));
        else
            $result[$prefix . $key] = $value;
    }
    return $result;
}
//SEND MQTT
function send_mqtt($id, $message)
{
    require_once "loxberry_io.php";
    require_once "phpMQTT.php";
    $creds     = mqtt_connectiondetails();
    $client_id = uniqid(gethostname() . "_client");
    $mqtt      = new Bluerhinos\phpMQTT($creds['brokerhost'], $creds['brokerport'], $client_id);
    if ($mqtt->connect(true, NULL, $creds['brokeruser'], $creds['brokerpass'])) {
        $message = prefixKey('', $message);
        foreach ($message as $x => $val) {
            echo 'solcast/' . $id . '/' . $x . '=' . $val . '<br>';
            $mqtt->publish("solcast/" . $id . "/" . $x, $val, 0, 1);
        }
        $mqtt->close();
    } else {
        echo "MQTT connection failed";
    }
}

//SEND UDP
function send_udp($id, $message, $ms_ip, $ms_port)
{
	foreach ($message as $k => $v) {
		$message['s_'.$id . '_' . $k] = $v;
        unset($message[$k]);
		
    }
	
    foreach ($message as $i => $value) {
        if (empty($value))
            $message[$i] = 0;
    }
	$new_message='';
	foreach ($message as $i => $value) {
		foreach ($value as $key => $x) {
			echo $i.'_'.$key.'='.$x.'<br>';
			$new_message.=$i.'_'.$key.'='.$x.' ';
		}
	}
    if ($socket = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP)) {
        socket_sendto($socket, $new_message, strlen($new_message), 0, $ms_ip, $ms_port);
    } else {
        print("can't create socket\n");
    }
}

//LOG
	function log_i ($text, $file_log) {
		$time_e=date("Y-m-d  H:i:s");
		$message_j = json_encode($text);
		echo $message_j.'<br>';
		$message_s =$time_e.' - ';
		$message_s .=$message_j;#
		
		echo $message_s.'<br>';
		$myfile = file_put_contents($file_log, $message_s.PHP_EOL , FILE_APPEND | LOCK_EX);
	}
	
//HTTP CODES
function http_codes($code) {
  $http_status_codes = array(
    100 => 'Informational: Continue',
    101 => 'Informational: Switching Protocols',
    102 => 'Informational: Processing',
    200 => 'Successful: OK',
    201 => 'Successful: Created',
    202 => 'Successful: Accepted',
    203 => 'Successful: Non-Authoritative Information',
    204 => 'Successful: No Content',
    205 => 'Successful: Reset Content',
    206 => 'Successful: Partial Content',
    207 => 'Successful: Multi-Status',
    208 => 'Successful: Already Reported',
    226 => 'Successful: IM Used',
    300 => 'Redirection: Multiple Choices',
    301 => 'Redirection: Moved Permanently',
    302 => 'Redirection: Found',
    303 => 'Redirection: See Other',
    304 => 'Redirection: Not Modified',
    305 => 'Redirection: Use Proxy',
    306 => 'Redirection: Switch Proxy',
    307 => 'Redirection: Temporary Redirect',
    308 => 'Redirection: Permanent Redirect',
    400 => 'Client Error: Bad Request',
    401 => 'Client Error: Unauthorized',
    402 => 'Client Error: Payment Required',
    403 => 'Client Error: Forbidden',
    404 => 'Client Error: Not Found',
    405 => 'Client Error: Method Not Allowed',
    406 => 'Client Error: Not Acceptable',
    407 => 'Client Error: Proxy Authentication Required',
    408 => 'Client Error: Request Timeout',
    409 => 'Client Error: Conflict',
    410 => 'Client Error: Gone',
    411 => 'Client Error: Length Required',
    412 => 'Client Error: Precondition Failed',
    413 => 'Client Error: Request Entity Too Large',
    414 => 'Client Error: Request-URI Too Long',
    415 => 'Client Error: Unsupported Media Type',
    416 => 'Client Error: Requested Range Not Satisfiable',
    417 => 'Client Error: Expectation Failed',
    418 => 'Client Error: I\'m a teapot',
    419 => 'Client Error: Authentication Timeout',
    420 => 'Client Error: Enhance Your Calm',
    420 => 'Client Error: Method Failure',
    422 => 'Client Error: Unprocessable Entity',
    423 => 'Client Error: Locked',
    424 => 'Client Error: Failed Dependency',
    424 => 'Client Error: Method Failure',
    425 => 'Client Error: Unordered Collection',
    426 => 'Client Error: Upgrade Required',
    428 => 'Client Error: Precondition Required',
    429 => 'Client Error: Too Many Requests',
    431 => 'Client Error: Request Header Fields Too Large',
    444 => 'Client Error: No Response',
    449 => 'Client Error: Retry With',
    450 => 'Client Error: Blocked by Windows Parental Controls',
    451 => 'Client Error: Redirect',
    451 => 'Client Error: Unavailable For Legal Reasons',
    494 => 'Client Error: Request Header Too Large',
    495 => 'Client Error: Cert Error',
    496 => 'Client Error: No Cert',
    497 => 'Client Error: HTTP to HTTPS',
    499 => 'Client Error: Client Closed Request',
    500 => 'Server Error: Internal Server Error',
    501 => 'Server Error: Not Implemented',
    502 => 'Server Error: Bad Gateway',
    503 => 'Server Error: Service Unavailable',
    504 => 'Server Error: Gateway Timeout',
    505 => 'Server Error: HTTP Version Not Supported',
    506 => 'Server Error: Variant Also Negotiates',
    507 => 'Server Error: Insufficient Storage',
    508 => 'Server Error: Loop Detected',
    509 => 'Server Error: Bandwidth Limit Exceeded',
    510 => 'Server Error: Not Extended',
    511 => 'Server Error: Network Authentication Required',
    598 => 'Server Error: Network read timeout error',
    599 => 'Server Error: Network connect timeout error',
);
  return $http_status_codes[$code];
}