<?php
require_once "loxberry_system.php";
require_once "loxberry_web.php";

$L           = LBWeb::readlanguage("language.ini");
$file_config = $lbpconfigdir . '/solcast_config.json';
$file_log_i  = $lbplogdir . '/solcast.log';
$htmlhead = "<style>
.tooltip {
  text-decoration:none;
  position:relative;
}
 
.tooltip span {
  display:none;
  -moz-border-radius:6px;
  -webkit-border-radius:6px;
  border-radius:6px;
  color:black;
  background:white; 
}
 
.tooltip span img {
  float:left;
}
 
.tooltip:hover span {
  display:block;
  position:absolute;
  top:0;
  left:0;
  z-index:1000;
  width:auto;
  border:1px solid black;
  overflow:hidden;
  padding:8px;
}
</style>";

if ($_POST) {
    if ($_POST['system_active1'] == "on") {
        $system_active1 = "1";
    } else {
        $system_active1 = "0";
    }
    if ($_POST['system_active2'] == "on") {
        $system_active2 = "1";
    } else {
        $system_active2 = "0";
    }
    if ($_POST['system_active3'] == "on") {
        $system_active3 = "1";
    } else {
        $system_active3 = "0";
    }
    if ($_POST['system_active4'] == "on") {
        $system_active4 = "1";
    } else {
        $system_active4 = "0";
    }	
    if ($_POST['system_active5'] == "on") {
        $system_active5 = "1";
    } else {
        $system_active5 = "0";
    }		
    if ($_POST['debug_active'] == "on") {
        $debug_active = "1";
    } else {
        $debug_active = "0";
    }
	if ($_POST['auto_active'] == "on") {
        $auto_active = "1";
    } else {
        $auto_active = "0";
    }
	if ($_POST['mn_ss_active'] == "on") {
        $mn_ss_active = "1";
    } else {
        $mn_ss_active = "0";
    }
	
	if ($_POST['return_mqtt'] == "on") { $return_mqtt = "1"; } else { $return_mqtt = "0"; }
	if ($_POST['return_udp'] == "on") { $return_udp = "1"; } else { $return_udp = "0"; }
	
    
    $data = '{
        "system_1": {
            "active": "' . $system_active1 . '",
            "api": "' . $_POST['apikey1'] . '",
            "rt_id": "' . $_POST['rt_id1'] . '",
			"note": "' . $_POST['note1'] . '"
        },
        "system_2": {
            "active": "' . $system_active2 . '",
            "api": "' . $_POST['apikey2'] . '",
            "rt_id": "' . $_POST['rt_id2'] . '",
			"note": "' . $_POST['note2'] . '"
        },
        "system_3": {
            "active": "' . $system_active3 . '",
            "api": "' . $_POST['apikey3'] . '",
            "rt_id": "' . $_POST['rt_id3'] . '",
			"note": "' . $_POST['note3'] . '"

        },
        "system_4": {
            "active": "' . $system_active4 . '",
            "api": "' . $_POST['apikey4'] . '",
            "rt_id": "' . $_POST['rt_id4'] . '",
			"note": "' . $_POST['note4'] . '"
        },
        "system_5": {
            "active": "' . $system_active5 . '",
            "api": "' . $_POST['apikey5'] . '",
            "rt_id": "' . $_POST['rt_id5'] . '",
			"note": "' . $_POST['note5'] . '"
        },		
		"miniserver": {
			"ip": "'.$_POST['miniserver'].'",
			"port": "'.$_POST['udpport'].'"
		},		
        "debug": "' . $debug_active . '",
		"auto": "' . $auto_active . '",
		"mn_ss": "' . $mn_ss_active . '",
        "timer": ' . json_encode($_POST['timer']) . ',
		"send_udp": "'.$return_udp.'",
		"send_mqtt": "'.$return_mqtt.'"
    }';
    
    $handle = fopen($file_config, "w");
    fwrite($handle, $data);
    fclose($handle);
}

$config = json_decode(file_get_contents($file_config), true);

$template_title = "Solcast";
$helplink       = $L['LINKS.WIKI'];

$helptemplate = "pluginhelp.html";

$navbar[1]['Name'] = $L['NAVBAR.FIRST'];
$navbar[1]['URL']  = 'index.php';
$navbar[2]['Name'] = $L['NAVBAR.SECOND'];
$navbar[2]['URL']  = 'log.php';

// NAVBAR
$navbar[1]['active'] = True;
LBWeb::lbheader($template_title, $helplink, $helptemplate);
echo '<img src="logo.png" alt="PV Solcast">';
echo '<p>' . $L['MAIN.INTRO1'] . '</p>';
echo '<form action="index.php" method="post">';
echo '
  <div class="ui-body ui-body-a ui-corner-all" >
<table style="width: 100%">
  <tr>
    <th >
    <div class="ui-body ui-body-a ui-corner-all">
    <h4>' . $L['USER.HEAD1'] . '</h4>
';
echo '<select name="system_active1" id="system_active1" data-role="slider" >
    <option value="off"';
if ($config['system_1']['active'] != 1) {
    echo 'selected';
}
echo '>Off</option>
    <option value="on"';
if ($config['system_1']['active'] == 1) {
    echo 'selected';
}
echo '>On</option>
</select>';

echo '<label for="apikey1" style="text-align:left;">' . $L['USER.API'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="apikey1" id="apikey1"  value="' . $config['system_1']['api'] . '" type="text">';
echo '<br><label for="rt_id1" style="text-align:left;">' . $L['USER.RT_ID'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="rt_id1" id="rt_id1"  value="' . $config['system_1']['rt_id'] . '" type="text">';
echo '<br><label for="rt_id1" style="text-align:left;">' . $L['USER.NOTE'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="note1" id="note1"  value="' . $config['system_1']['note'] . '" type="text">';
echo '
</div></th>
    <th><div class="ui-body ui-body-a ui-corner-all" style="margin-left: 10px; margin-right: 10px;">
    <h4>' . $L['USER.HEAD2'] . '</h4>';
echo '<select name="system_active2" id="system_active2" data-role="slider" >
    <option value="off"';
if ($config['system_2']['active'] != 1) {
    echo 'selected';
}
echo '>Off</option>
    <option value="on"';
if ($config['system_2']['active'] == 1) {
    echo 'selected';
}
echo '>On</option>
</select>';

echo '<label for="apikey2" style="text-align:left;">' . $L['USER.API'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="apikey2" id="apikey2"  value="' . $config['system_2']['api'] . '" type="text">';
echo '<br><label for="rt_id2" style="text-align:left;">' . $L['USER.RT_ID'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="rt_id2" id="rt_id2"  value="' . $config['system_2']['rt_id'] . '" type="text">';
echo '<br><label for="rt_id1" style="text-align:left;">' . $L['USER.NOTE'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="note2" id="note2"  value="' . $config['system_2']['note'] . '" type="text">';
echo '
</div></th>
    <th><div class="ui-body ui-body-a ui-corner-all" style="margin-left: 10px; margin-right: 10px;">
    <h4>' . $L['USER.HEAD3'] . '</h4>';
echo '<select name="system_active3" id="system_active3" data-role="slider" >
    <option value="off"';
if ($config['system_3']['active'] != 1) {
    echo 'selected';
}
echo '>Off</option>
    <option value="on"';
if ($config['system_3']['active'] == 1) {
    echo 'selected';
}
echo '>On</option>
</select>';
echo '<label for="apikey3" style="text-align:left;">' . $L['USER.API'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="apikey3" id="apikey3"  value="' . $config['system_3']['api'] . '" type="text">';
echo '<br><label for="rt_id3" style="text-align:left;">' . $L['USER.RT_ID'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="rt_id3" id="rt_id3"  value="' . $config['system_3']['rt_id'] . '" type="text">';
echo '<br><label for="rt_id1" style="text-align:left;">' . $L['USER.NOTE'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="note3" id="note3"  value="' . $config['system_3']['note'] . '" type="text">';
echo '
</div></th>
    <th><div class="ui-body ui-body-a ui-corner-all">
    <h4>' . $L['USER.HEAD4'] . '</h4>';
echo '<select name="system_active4" id="system_active4" data-role="slider" >
    <option value="off"';
if ($config['system_4']['active'] != 1) {
    echo 'selected';
}
echo '>Off</option>
    <option value="on"';
if ($config['system_4']['active'] == 1) {
    echo 'selected';
}
echo '>On</option>
</select>';
echo '<label for="apikey4" style="text-align:left;">' . $L['USER.API'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="apikey4" id="apikey4"  value="' . $config['system_4']['api'] . '" type="text">';
echo '<br><label for="rt_id4" style="text-align:left;">' . $L['USER.RT_ID'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="rt_id4" id="rt_id4"  value="' . $config['system_4']['rt_id'] . '" type="text">';
echo '<br><label for="rt_id1" style="text-align:left;">' . $L['USER.NOTE'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="note4" id="note4"  value="' . $config['system_4']['note'] . '" type="text">';
echo '
</div></th>
    <th><div class="ui-body ui-body-a ui-corner-all">
    <h4>' . $L['USER.HEAD5'] . '</h4>';
echo '<select name="system_active5" id="system_active5" data-role="slider" >
    <option value="off"';
if ($config['system_5']['active'] != 1) {
    echo 'selected';
}
echo '>Off</option>
    <option value="on"';
if ($config['system_5']['active'] == 1) {
    echo 'selected';
}
echo '>On</option>
</select>';
echo '<label for="apikey5" style="text-align:left;">' . $L['USER.API'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="apikey5" id="apikey5"  value="' . $config['system_5']['api'] . '" type="text">';
echo '<br><label for="rt_id5" style="text-align:left;">' . $L['USER.RT_ID'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="rt_id5" id="rt_id5"  value="' . $config['system_5']['rt_id'] . '" type="text">';
echo '<br><label for="rt_id1" style="text-align:left;">' . $L['USER.NOTE'] . '</label>';
echo '<input data-inline="true" data-mini="true" name="note5" id="note5"  value="' . $config['system_5']['note'] . '" type="text">';
echo ' </tr>
</table>
</div>';

echo'<div class="ui-body ui-body-a ui-corner-all" >';
echo'<label for="debug_active" style="text-align:left;">' . $L['SYSTEM.MN_SS'] . '</label>';
echo '<select name="mn_ss_active" id="mn_ss_active" data-role="slider" >
    <option value="off"';
if ($config['mn_ss'] != 1) {
    echo 'selected';
}
echo '>Off</option>
<option value="on"';
if ($config['mn_ss'] == 1) {
    echo 'selected';
}
echo '>On</option></select><hr>';

echo '<label for="debug_active" style="text-align:left;">' . $L['SYSTEM.AUTO'] . '</label>';
echo '<select name="auto_active" id="auto_active" data-role="slider" >
    <option value="off"';
if ($config['auto'] != 1) {
    echo 'selected';
}
echo '>Off</option>
    <option value="on"';
if ($config['auto'] == 1) {
    echo 'selected';
}
echo '>On</option>
</select>

<label for="timer" class="select">' . $L['SYSTEM.TIMER'] . '</label>
<select name="timer[]" id="timer" multiple="multiple" data-native-menu="false" data-icon="grid" data-iconpos="left">
    <option>Choose a few options:</option>';

for ($x = 4; $x <= 22; $x++) {
    echo '<option value="' . $x . '"';
    if (in_array($x, $config['timer'])) {
        echo " selected";
    }
    echo '>' . $x . ':00</option>';
}
echo '</select>';
echo '</div>';

echo'<div class="ui-body ui-body-a ui-corner-all" >';
  echo '<p class="wide">'. $L['MINISERVER.HEAD']. '</p>';
//MiniServers 
$ms = LBSystem::get_miniservers();
foreach ($ms as $element) { if ($element['IPAddress'] == $config['miniserver']['ip']) { $miniserver_name= $element['Name']; }}
if (!is_array($ms)) {
    echo $L['MINISERVER.NOMS'];
} else {
	echo '<label for="miniserver">'.$L['MINISERVER.CHOOSE'].'</label>';
	echo '<select name= "miniserver" id="miniserver">';
	echo '<option select value="'.$config['miniserver']['ip'].'">'.$miniserver_name.'</option>';
	echo '<option></option>';
	foreach ($ms as $miniserver) {
	echo '<option value="'.$miniserver['IPAddress'].'">'.$miniserver['Name'].'</option>';
	}	
	echo '</select>';
}
echo '<br><br><p class="wide">'. $L['RETURN.HEAD']. '</p>';
echo '<label for="return_mqtt">'.$L['RETURN.MQTT'].'</label>';
echo '<input type="checkbox" id="return_mqtt" name="return_mqtt"'; if ($config['send_mqtt'] > 0) { echo"checked"; }; echo '>';
echo '<label for="return_udp">'.$L['RETURN.UDP'].'</label>';
echo '<input type="checkbox" id="return_udp" name="return_udp"'; if ($config['send_udp'] > 0) { echo"checked"; }; echo '>';
echo $L['RETURN.UDP_PORT'];
echo '<input data-inline="true"  data-mini="true" name="udpport" id="udpport"  value="'. $config['miniserver']['port']. '" type="text">';
echo '</div>';


echo'<div class="ui-body ui-body-a ui-corner-all" >
<label for="debug_active" style="text-align:left;">' . $L['SYSTEM.DEBUG'] . '</label>';
echo '<select name="debug_active" id="debug_active" data-role="slider" >
    <option value="off"';
if ($config['debug'] != 1) {
    echo 'selected';
}
echo '>Off</option>
    <option value="on"';
if ($config['debug'] == 1) {
    echo 'selected';
}
echo '>On</option>
</select>
</div>';
echo '<br><p><center><input data-role="button" data-inline="true" data-mini="true" type="submit" name="save_new" data-icon="check" value=' . $L['MAIN.SAVE'] . '> </center></p>';
echo '</form>';
LBWeb::lbfooter();
?>
